I am not 100% sure if you can have this error and start a game solo queue without updating version but I was partied with someone with an updated patch of DotA2 and we had finally been matched when I received an error message saying I did not have the correct version of the map (because I did not update). There should be an automatic update to the patch without having to restart steam or at the very least give off a warning or not be capable of partying with other players with different versions.